> For the complete documentation index, see [llms.txt](https://docs.resolv.xyz/litepaper/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.resolv.xyz/litepaper/resources/security.md).

# Security

### Wallet allowlisting

At the current stage, access to minting and redeeming Resolv tokens is available to allowlisted wallets. To gain access, [fill out a form](https://resolv.typeform.com/to/AEaQlqcz).

### Immunefi bug bounty program

Resolv maintains a public [bug bounty program](https://immunefi.com/bug-bounty/resolv/information/) at Immunefi.

### Smart contract audits

#### **ExternalRequestsCoordinator (Jan 2026)**

| Audit Firm | Report                                                                                           |
| ---------- | ------------------------------------------------------------------------------------------------ |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/ExternalRequestsCoordinator) |

#### **ResolvStakingV2 (Jul - Aug 2025)**

| Audit Firm | Report                                                                                              |
| ---------- | --------------------------------------------------------------------------------------------------- |
| Pashov     | [Link](https://github.com/pashov/audits/blob/master/team/pdf/Resolv-security-review_2025-07-25.pdf) |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Staking)                        |

#### **EtherFiTreasuryExtension (Jul 2025)**

| Audit Firm | Report                                                                                              |
| ---------- | --------------------------------------------------------------------------------------------------- |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Treasury%20EtherFI%20Extension) |

#### **RlpUpOnlyPriceStorage, Multicall (Jul 2025)**

| Audit Firm | Report                                                                     |
| ---------- | -------------------------------------------------------------------------- |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Utils) |

#### **ResolvStaking, RewardDistributor with dripper (Apr - May 2025)**

| Audit Firm | Report                                                                                                                                                                                                   |
| ---------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Staking)                                                                                                                             |
| Pashov     | [Link](https://github.com/pashov/audits/blob/master/team/pdf/Resolv-security-review_2025-04-15.pdf), [Link](https://github.com/pashov/audits/blob/master/team/pdf/Resolv-security-review_2025-05-14.pdf) |

#### **TreasuryIntermediateEscrow (March 2025)**

| Audit Firm | Report                                                                                 |
| ---------- | -------------------------------------------------------------------------------------- |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Treasury%20Escrow) |

#### **LidoTreasuryExtension (December 2024)**

| Audit Firm | Report                                                                                    |
| ---------- | ----------------------------------------------------------------------------------------- |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/Treasury%20Extension) |

#### **TheCounter, UsrPriceStorage, RlpPriceStorage, ExternalRequestsManager, UsrRedemptionExtension (December 2024)**

| Audit Firm | Report                                                                                              |
| ---------- | --------------------------------------------------------------------------------------------------- |
| Pashov     | [Link](https://github.com/pashov/audits/blob/master/team/pdf/Resolv-security-review_2024-12-09.pdf) |
| MixBytes   | [Link](https://github.com/mixbytes/audits_public/tree/master/Resolv/PoR%20Oracles)                  |

#### **Treasury Smart Contract, Request Managers, stUSR, wstUSR, USR, RLP, RewardDistributor Contracts (November 2024)**

| Audit Firm | Report                                                                                                                                         |
| ---------- | ---------------------------------------------------------------------------------------------------------------------------------------------- |
| Sherlock   | [Link](https://github.com/sherlock-protocol/sherlock-reports/blob/main/audits/2024.12.02%20-%20Final%20-%20Resolv%20Core%20Audit%20Report.pdf) |

#### **Treasury Smart Contract, Request Manager Contracts (August - September 2024)**

| Audit Firm | Report                                                                                  |
| ---------- | --------------------------------------------------------------------------------------- |
| MixBytes   | [PDF](https://drive.google.com/open?id=11QMgK6JWcxS_-nkPUHDK-J2vtselsXRT\&usp=drive_fs) |
| Pashov     | [PDF](https://drive.google.com/open?id=11F6pruh8kqiv0jER0kylc7Sw9WsbLj0K\&usp=drive_fs) |

#### Wrapped Staking (wstUSR) (July - August 2024)

| Audit Firm  | Report                                                                                       |
| ----------- | -------------------------------------------------------------------------------------------- |
| Pessimistic | [PDF](https://drive.google.com/file/d/1SkLMHNnajC9HcwYmsz24F17shIJkd46B/view?usp=drive_link) |
| Pashov      | [PDF](https://drive.google.com/file/d/1SlU9_xp4QHSE_Ux8kJ454quR1j67Er8l/view?usp=drive_link) |

#### Token Contracts, Request Manager Contracts, Staking Contract (May - June 2024)

| Audit Firm  | Report                                                                                       |
| ----------- | -------------------------------------------------------------------------------------------- |
| MixBytes    | [PDF](https://drive.google.com/file/d/1K1VjrE8EdpONfn6hzHRlXDLo29bpcoTt/view?usp=drive_link) |
| Pessimistic | [PDF](https://drive.google.com/file/d/1K6VAIjZTEE5FmqXN11LZPRMWNxapLjq7/view?usp=drive_link) |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.resolv.xyz/litepaper/resources/security.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
